﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FFT_Template
{
    public class Filters : FourierDemo
    {
        public static Complex[][][] IdealBandpassFilter(Complex[][][] frequencies, double d0, double W)
        {
            Complex[][][] filtered = frequencies;
            for (int i = 0; i < 3; i++)
            {
                for (int u = 0; u < Size; u++)
                {
                    for (int v = 0; v < Size; v++)
                    {
                        double d = Math.Sqrt((Math.Pow(u - Size / 2, 2) + Math.Pow(v - Size / 2, 2)));
                        if (d <= (d0 - W/2) || d >= (d0 + W/2))
                        {
                            filtered[i][u][v] *= 0f;
                        }
                    }
                }
            }

            return filtered;
        }

        public static Complex[][][] ButterworthBandpassFilter(Complex[][][] frequencies, double d0, int n, double W)
        {
            Complex[][][] filtered = frequencies;
            for (int i = 0; i < 3; i++)
            {
                for (int u = 0; u < Size; u++)
                {
                    for (int v = 0; v < Size; v++)
                    {
                        double d = Math.Sqrt((Math.Pow(u - Size / 2, 2) + Math.Pow(v - Size / 2, 2)));
                        filtered[i][u][v] *= 1f - (float)(1f / (1 + Math.Pow(d * W / (d*d - d0*d0), 2 * n)));
                    }
                }
            }

            return filtered;
        }

        public static Complex[][][] GaussianBandpassFilter(Complex[][][] frequencies, double d0, double W)
        {
            Complex[][][] filtered = frequencies;
            for (int i = 0; i < 3; i++)
            {
                for (int u = 0; u < Size; u++)
                {
                    for (int v = 0; v < Size; v++)
                    {
                        double d = Math.Sqrt((Math.Pow(u - Size / 2, 2) + Math.Pow(v - Size / 2, 2)));
                        filtered[i][u][v] *= (float)(Math.Pow(Math.E, (-Math.Pow((d*d - d0*d0) / (d * W), 2))));
                    }
                }
            }

            return filtered;
        }
    }
}
